#include <stdlib.h>
#include <avr\io.h>



#define	BAUD_RATE_LOW_REG	      UBRRL
#define	UART_CONTROL_REG	      UCSRB
#define	ENABLE_TRANSMITTER_BIT	TXEN
#define	ENABLE_RECEIVER_BIT	    RXEN
#define	UART_STATUS_REG	        UCSRA
#define	TRANSMIT_COMPLETE_BIT	  TXC
#define	RECEIVE_COMPLETE_BIT	  RXC
#define	UART_DATA_REG	          UDR


void inituart(void)
{
  BAUD_RATE_LOW_REG = 35;                           // 19200bps 
  UART_CONTROL_REG = (1 << ENABLE_RECEIVER_BIT) |
                     (1 << ENABLE_TRANSMITTER_BIT); // enable receive and transmit 
}


void sendchar(char c)
{
  UART_DATA_REG = c;                                   // prepare transmission
  while (!(UART_STATUS_REG & (1 << TRANSMIT_COMPLETE_BIT)));// wait until byte sendt
  UART_STATUS_REG |= (1 << TRANSMIT_COMPLETE_BIT);          // delete TXCflag
}


char recchar(void)
{
  while(!(UART_STATUS_REG & (1 << RECEIVE_COMPLETE_BIT)));  // wait for data
  return UART_DATA_REG;
}

void sputs(char* str)
{
  while (*str) {
    sendchar(*str);
    str++;
  }
//  sendchar('\n');
//  sendchar('\r');
}

